var main = main || {};
main.init = function () {

    //http://jsfiddle.net/phillipkerman/aShay/
    //inheritance the "normal" way and prototype chain


    function Parent() {
        this.extra = "extra for parent";
        this.prop = "parent prop";
    }

    function Child() {
        this.prop = "child prop";
    }
    Child.prototype = new Parent();

    var childInstance = new Child();

    //demo how it goes up the __proto__ chain
    //delete childInstance.prop;
    console.log(childInstance.prop);

    //above is not an "is a" relationship

    //random gymnastics leading to Object.create
    var test = {};
    Child.call(test);
    //console.log( test.prop );

    var p = {
        prop: "someProp",
        extraProp: "extra"
    };

    //Object.create will give you a new function instance
    //with its prototype set to the object you pass
    var t = Object.create( p );
    //console.log( t.prop );

    //incase Object.create() isn't supported:
    if(typeof Object.create !== "function") {
        Object.create = function (o) {
            function F() {}
            F.prototype = o;
            return new F();
        };
    }
};